//#include <p32xxxx.h>
#include <xc.h>
#include <sys/asm.h>
#include "ISR_Support.h"

	.set	nomips16
	.set 	noreorder
	.extern xISRStackTop


/* UART 2 */

	.extern vU2RXInterruptHandler
	.extern vU2TXInterruptHandler
	.extern vU2FAULTInterruptHandler

	.global	vU2RXInterruptWrapper
	.global	vU2TXInterruptWrapper
	.global	vU2FAULTInterruptWrapper



// Uart 2 RX Interrupt

	.set	noreorder
	.set 	noat
	.ent	vU2RXInterruptWrapper

vU2RXInterruptWrapper:

	portSAVE_CONTEXT
	jal vU2RXInterruptHandler
	nop
	portRESTORE_CONTEXT

	.end	vU2RXInterruptWrapper


// Uart 2 TX Interrupt

	.set	noreorder
	.set 	noat
	.ent	vU2TXInterruptWrapper

vU2TXInterruptWrapper:

	portSAVE_CONTEXT
	jal vU2TXInterruptHandler
	nop
	portRESTORE_CONTEXT

	.end	vU2TXInterruptWrapper


// Uart 2 Error-Fault Interrupt

	.set	noreorder
	.set 	noat
	.ent	vU2FAULTInterruptWrapper

vU2FAULTInterruptWrapper:

	portSAVE_CONTEXT
	jal vU2FAULTInterruptHandler
	nop
	portRESTORE_CONTEXT

	.end	vU2FAULTInterruptWrapper


